#include "mv.hh"
#include "TimeMeter.hh"
#include <iostream>

using namespace std ;

#define TEST(MM) \
  timeStart() ; \
  for ( int i = 0 ; i < NLOOP ; ++i ) { \
    MM( A, B, C ) ; \
    MM( C, B, A ) ; \
    MM( A, B, C ) ; \
    MM( C, B, A ) ; \
    MM( A, B, C ) ; \
    MM( C, B, A ) ; \
    MM( A, B, C ) ; \
    MM( C, B, A ) ; \
    MM( A, B, C ) ; \
    MM( C, B, A ) ; \
  } \
  elapsed = timeStop() ; \
  cout << #MM << " time = " << elapsed/(10*NLOOP) << '\n'

#define TESTT(TS) \
  timeStart() ; \
  for ( int i = 0 ; i < NLOOP ; ++i ) { \
    Mat_x_Mat_with_tiling( A, B, C, TS ) ; \
    Mat_x_Mat_with_tiling( C, B, A, TS ) ; \
    Mat_x_Mat_with_tiling( A, B, C, TS ) ; \
    Mat_x_Mat_with_tiling( C, B, A, TS ) ; \
    Mat_x_Mat_with_tiling( A, B, C, TS ) ; \
    Mat_x_Mat_with_tiling( C, B, A, TS ) ; \
    Mat_x_Mat_with_tiling( A, B, C, TS ) ; \
    Mat_x_Mat_with_tiling( C, B, A, TS ) ; \
    Mat_x_Mat_with_tiling( A, B, C, TS ) ; \
    Mat_x_Mat_with_tiling( C, B, A, TS ) ; \
  } \
  elapsed = timeStop() ; \
  cout << "Mat_x_Mat_with_tiling(" << TS << ") time = " << elapsed/(10*NLOOP) << '\n'

int
main() {
  struct Vec a, b, c ;
  struct Mat A, B, C ;

  a.Allocate( 100 ) ;
  b.Allocate( 100 ) ;
  c.Allocate( 100 ) ;
  
  int N = 500 ;

  A.AllocateAndInitializeRandom( N, N ) ;
  B.AllocateAndInitializeRandom( N, N ) ;
  C.Allocate( N, N ) ;
  
  int NLOOP = 2 ;

  timeStart() ;
  for ( int i = 0 ; i < NLOOP ; ++i ) {
    Mat_x_Mat_123( A, B, C ) ;
    Mat_x_Mat_123( C, B, A ) ;
    Mat_x_Mat_123( A, B, C ) ;
    Mat_x_Mat_123( C, B, A ) ;
    Mat_x_Mat_123( A, B, C ) ;
    Mat_x_Mat_123( C, B, A ) ;
    Mat_x_Mat_123( A, B, C ) ;
    Mat_x_Mat_123( C, B, A ) ;
    Mat_x_Mat_123( A, B, C ) ;
    Mat_x_Mat_123( C, B, A ) ;
  }
  double elapsed = timeStop() ;
  cout << "Mat_x_Mat_123 time = " << elapsed/(10*NLOOP) << '\n' ;

  TEST(Mat_x_Mat_132) ;
  TEST(Mat_x_Mat_213) ;
  TEST(Mat_x_Mat_231) ;
  TEST(Mat_x_Mat_312) ;
  TEST(Mat_x_Mat_321) ;

  TESTT( 10 ) ;
  TESTT( 20 ) ;
  TESTT( 40 ) ;
  TESTT( 80 ) ;
  TESTT( 120 ) ;
  TESTT( 160 ) ;

}
